﻿/* 
    SQL Saturday #626 Budapest
	Hacking SQL Server
    2017-05-06 (version 1.29)
    Demo 1 - TCP packets sniffing
    Demo 2 - TCP packets manipulation
    Demo 3 - Obtaining Access and Escalation Privileges
    Demo 4 - Protect by encrypting TDS
    André Melancia
    http://Andy.PT

    (C) 2016-2017, André Melancia
    
           ________   ________    _________  ____________;_
          - ______ \ - ______ \ / _____   //.  .  ._______/
         / /     / // /     / //_/     / // ___   /
        / /     / // /     / /       .-'//_/|_/,-'
       / /     / // /     / /     .-'.-'
      / /     / // /     / /     / /
     / /     / // /     / /     / /
    / /_____/ // /_____/ /     / /
    \________- \________-     /_/
         
*/

--  +----------------------------------------------------------------+
--  | MISSION BRIEFING                                               |
--  +----------------------------------------------------------------+

    -- You are an NSA agent trying to hack an MI6 server.
    -- Your mission, if you decide to accept it, is to infiltrate
    -- NSA agents in MI6 missions.
    -- After your mission preparation, you must run the demos in the
    -- order shown.
    -- As always, if you don't run these scripts on an EMPTY database,
    -- the Secretary will disavow any knowledge of your actions. 
    -- This script will NOT self-destruct in five seconds.
    
    -- Info:
    -- Because of Windows Kernel optimisations, you can't capture
    -- traffic from Localhost to same Localhost. You need to have the
    -- client (SSMS) and the SQL Server DE on different machines.

    -- WARNING:
    -- DON'T RUN THIS ON A PRODUCTION MACHINE. USE TEST MACHINES ONLY!
    
    -- These are ethical hacking scripts. 
    -- Do not use them for evil (pranking is fine).


--  +----------------------------------------------------------------+
--  | MISSION PREPARATION                                            |
--  +----------------------------------------------------------------+

    USE SQLSatBudapest;     -- Or whatever database you created!
                            -- Please don't run this on the Master, that's
                            -- just ugly!
    GO

    -- Things an MI6 agent with Licence to KILL has to do
    -- Note: "IF EXISTS" are ugly. First time these will generate errors
    --       Just accept the errors as part of an agent's life ;)
    DROP USER M;
    DROP USER Q;
    DROP USER Sean;
    DROP USER David;
    DROP USER George;
    DROP USER Roger;
    DROP USER Timothy;
    DROP USER Pierce;
    DROP USER Daniel;
    GO
    
    DROP SECURITY POLICY AgentValidationPolicy
    GO
    DROP FUNCTION MI6_Access.FN_MI6_AgentValidationPredicate;
    GO
    DROP SCHEMA   MI6_Access;
    GO

    DROP VIEW     dbo.VIEW_BondFilms;
    GO
    DROP TABLE    dbo.BondFilms;
    GO
    DROP TABLE    dbo.Agents;
    GO
    DROP TABLE    dbo.Letters;
    GO


--  +----------------------------------------------------------------+
--  | CREATE TABLE dbo.BondFilms                                     |
--  +----------------------------------------------------------------+

    CREATE TABLE dbo.BondFilms
    (
        FilmID       INT           NOT NULL,
        FilmTitle_EN NVARCHAR(64)  NOT NULL,
        FilmYear     INT           NOT NULL,
        BondActor    NVARCHAR(64)  NOT NULL,
        Agent        SYSNAME       NOT NULL,
        Payment      INT           NOT NULL,
        CONSTRAINT PK_BondFilms PRIMARY KEY CLUSTERED  ( FilmID ASC ) 
    );


    -- Insert some REAL top secret for-your-eyes-only information
    -- Leaked from here: https://en.wikipedia.org/wiki/List_of_James_Bond_films
    INSERT INTO dbo.BondFilms
    (FilmID, FilmTitle_EN, FilmYear, BondActor, Agent, Payment) 
    VALUES 
    ( 1, 'Dr. No',                           1962, 'Sean Connery',   'Sean',      10000),
    ( 2, 'From Russia with Love',            1963, 'Sean Connery',   'Sean',      10000),
    ( 3, 'Goldfinger',                       1964, 'Sean Connery',   'Sean',      10000),
    ( 4, 'Thunderball',                      1965, 'Sean Connery',   'Sean',      10000),
    ( 5, 'Casino Royale',                    1967, 'David Niven',    'David',     10000),
    ( 6, 'You Only Live Twice',              1967, 'Sean Connery',   'Sean',      10000),
    ( 7, 'On Her Majesty''s Secret Service', 1969, 'George Lazenby', 'George',    10000),
    ( 8, 'Diamonds Are Forever',             1971, 'Sean Connery',   'Sean',      10000),
    ( 9, 'Live and Let Die',                 1973, 'Roger Moore',    'Roger',     10000),
    (10, 'The Man with the Golden Gun',      1974, 'Roger Moore',    'Roger',     10000),
    (11, 'The Spy Who Loved Me',             1977, 'Roger Moore',    'Roger',     10000),
    (12, 'Moonraker',                        1979, 'Roger Moore',    'Roger',     10000),
    (13, 'For Your Eyes Only',               1981, 'Roger Moore',    'Roger',     10000),
    (14, 'Octopussy',                        1983, 'Roger Moore',    'Roger',     10000),
    (15, 'Never Say Never Again',            1983, 'Sean Connery',   'Sean',    3552822), /* 3552822 = 0x363636 = "36 36 36 00" little endian */
    (16, 'A View to a Kill',                 1985, 'Roger Moore',    'Roger',     10000),
    (17, 'The Living Daylights',             1987, 'Timothy Dalton', 'Timothy',   10000),
    (18, 'Licence to Kill',                  1989, 'Timothy Dalton', 'Timothy',   10000),
    (19, 'GoldenEye',                        1995, 'Pierce Brosnan', 'Pierce',    10000),
    (20, 'Tomorrow Never Dies',              1997, 'Pierce Brosnan', 'Pierce',    10000),
    (21, 'The World Is Not Enough',          1999, 'Pierce Brosnan', 'Pierce',    10000),
    (22, 'Die Another Day',                  2002, 'Pierce Brosnan', 'Pierce',    10000),
    (23, 'Casino Royale',                    2006, 'Daniel Craig',   'Daniel',  3552822), /* 3552822 = 0x363636 = "36 36 36 00" little endian */
    (24, 'Quantum of Solace',                2008, 'Daniel Craig',   'Daniel',    10000),
    (25, 'Skyfall',                          2012, 'Daniel Craig',   'Daniel',    10000),
    (26, 'Spectre',                          2015, 'Daniel Craig',   'Daniel',    10000);


    -- Super advanced top secret spying technique
    SELECT * FROM dbo.BondFilms;

    GO


--  +----------------------------------------------------------------+
--  | Demo 1 (TCP packets sniffing)                                  |
--  +----------------------------------------------------------------+

    -- This will not work on local-to-local machine due to Windows 
    -- kernel architecture (good security!). You need to run it
    -- on a local-to-remote machine.
    -- Use Wireshark (or other) to sniff traffic (configure it to look 
    -- for the TDS protocol).
    -- Include the comments to be help locate the query in the packet.
    -- Run this as a block:
    
    -- <START_OF_BLOCK>
    
        /* Sniffing COMMENT 01: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Sniffing COMMENT 02: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Sniffing COMMENT 03: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Sniffing COMMENT 04: xxxxxxxxxxxxxxxxxxxxxxxxxxx */

        /* Stupid comment: RUN THIS WITH USER <<<AGENT123>>> and PASSWORD <<<123>>> */

        SELECT *, 'Sniffing Demo', GETDATE() FROM dbo.BondFilms;                                                                     

        /* Sniffing COMMENT 11: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Sniffing COMMENT 12: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Sniffing COMMENT 13: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Sniffing COMMENT 14: xxxxxxxxxxxxxxxxxxxxxxxxxxx */

    -- </END_OF_BLOCK>


--  +----------------------------------------------------------------+
--  | Demo 2 (TCP packets manipulation)                              |
--  +----------------------------------------------------------------+

    -- Use the TCP Proxy to simulate a ManInTheMiddle attack.
    -- Run this as a block on a <<<NEW>>> connection to the LOCAL 
    -- machine and port you selected on the C# example 
    -- (don't forget to change to the database you selected):
    
    -- Verify that this is the right server and database:
        SELECT @@SERVERNAME As CurrentServer, DB_NAME() as CurrentDB
        
    -- <START_OF_BLOCK>

        /* ManInTheMiddle COMMENT 01: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 02: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 03: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 04: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
 
        SELECT *, 'ManInTheMiddle Demo', GETDATE() FROM dbo.BondFilms;

        /* ManInTheMiddle COMMENT 11: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 12: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 13: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 14: xxxxxxxxxxxxxxxxxxxxxxxxxxx */

    -- </END_OF_BLOCK>


--  +----------------------------------------------------------------+
--  | Demo 3 (Obtaining Access and Escalationg Privileges)           |
--  +----------------------------------------------------------------+

    -- Use the TCP Proxy to change the request query text.
    -- Warning: for this to work, the user must have "sysadmin"
    -- or "securityadmin" privileges.
    -- Run this as a block on a NEW connection to the LOCAL 
    -- machine and port you selected on the C# example 
    -- (don't forget to change to the database you selected):
    
    -- <START_OF_BLOCK>

        /* Access&Escalation COMMENT 01: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Access&Escalation COMMENT 02: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Access&Escalation COMMENT 03: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Access&Escalation COMMENT 04: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
 
        SELECT 'EscalationExample Demo', GETDATE();                                                                                            
                                                                                                                                   
        /* Access&Escalation COMMENT 11: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Access&Escalation COMMENT 12: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Access&Escalation COMMENT 13: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* Access&Escalation COMMENT 14: xxxxxxxxxxxxxxxxxxxxxxxxxxx */

    -- </END_OF_BLOCK>

--  +----------------------------------------------------------------+
--  | Demo 4 (TCP packets manipulation after encryption)             |
--  +----------------------------------------------------------------+

    -- Go to the SQL Server Configuration Manager -> SQL Server Network
    -- Configuration -> Properties and enable "Force Encryption"
    -- Restart the server and try this query again
    
    -- Verify that this is the right server and database:
        SELECT @@SERVERNAME As CurrentServer, DB_NAME() as CurrentDB
        
    -- <START_OF_BLOCK>

        /* ManInTheMiddle COMMENT 01: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 02: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 03: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 04: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
 
        SELECT *, 'ManInTheMiddle Demo Again', GETDATE() FROM dbo.BondFilms;

        /* ManInTheMiddle COMMENT 11: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 12: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 13: xxxxxxxxxxxxxxxxxxxxxxxxxxx */
        /* ManInTheMiddle COMMENT 14: xxxxxxxxxxxxxxxxxxxxxxxxxxx */

    -- </END_OF_BLOCK>


--  +----------------------------------------------------------------+
--  | Mission cleanup                                                |
--  +----------------------------------------------------------------+

    -- You must delete any exploit users or junk you created on the 
    -- test server.


--  +----------------------------------------------------------------+
--  | Mission is now over.                                           |
--  | You can't run away with the Bond Girl because you're an NSA    |
--  | agent, not an MI6 agent.                                       |
--  | Consider changing sides: MI6 has better... eh... cars...       |
--  +----------------------------------------------------------------+
